#!/bin/sh

. ./base-config.sh

QUERY_STRING=$(./base-http2text.sh $QUERY_STRING)

CHANNEL=$(echo $QUERY_STRING | cut -d"+" -f2)

CMD=$(echo $QUERY_STRING | cut -d"?" -f1 | cut -d"=" -f1)

if [ "$CMD" = "del" ] ; then
  SVDRCOMMAND=$(echo $QUERY_STRING | cut -d"=" -f2 | tr -s "+" " ")
fi

if [ "$CMD" = "stimer" ] ; then

    #echo $QUERY_STRING

    string=$(echo $QUERY_STRING | tr -s "&" " ")

    for i in $(echo $string)
    do
      #echo "<p>$i</p>"
      case $i in
          channel*) channel=$(echo $i | cut -d"=" -f2) ;;
          day*) day=$(echo $i | cut -d"=" -f2)
                days=$(echo $days" "$day )
              ;;
          start_hour*) start_hour=$(echo $i | cut -d"=" -f2) ;;
          start_min*) start_min=$(echo $i | cut -d"=" -f2) ;;
          end_hour*) end_hour=$(echo $i | cut -d"=" -f2) ;;
          end_min*) end_min=$(echo $i | cut -d"=" -f2) ;;
          prio*) prior=$(echo $i | cut -d"=" -f2) ;;
          title*) title=$(echo $i | cut -d"=" -f2 | tr -s "+" " ") ;;
      esac
    done

    MARGINSTART=$(cat $VDRCONF/setup.conf | grep "^MarginStart =" | cut -d" " -f3)
    MARGINSTOP=$(cat $VDRCONF/setup.conf | grep "^MarginStop =" | cut -d" " -f3)

    start=$(echo $start_hour:$start_min)
    end=$(echo $end_hour:$end_min)

    stimesec=$(date -d "$start" +%s)
	   etimesec=$(date -d "$end" +%s)

        stimesec=$(($stimesec - $(($MARGINSTART*60))))
        etimesec=$(($etimesec + $(($MARGINSTOP*60))))

	# orginal: -eq 1
	if [ $REEL -ge 0 ] ; then
		start=$(date -d@$stimesec "+%H%M")
		end=$(date -d@$etimesec "+%H%M")
	else
	        start=$(echo -n $stimesec | awk '{ print strftime("%H%M", $0) }')
	        end=$(echo -n $etimesec | awk '{ print strftime("%H%M", $0) }')
        fi



    if [ $(($start - $start_hour)) -ge 2200 ] ; then
      shiftday=1
    else
      shiftday=0
    fi


    for i in 1 2 3 4 5 6 7
    do
          case $i in
              1)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"M")
                  else
                    date=$(echo $date"-")
                  fi ;;
              2)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"D")
                  else
                    date=$(echo $date"-")
                  fi ;;
              3)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"M")
                  else
                    date=$(echo $date"-")
                  fi ;;
              4)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"D")
                  else
                    date=$(echo $date"-")
                  fi ;;
              5)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"F")
                  else
                    date=$(echo $date"-")
                  fi ;;
              6)  c=$(echo $days | grep -c $(($i+$shiftday)))
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"S")
                  else
                    date=$(echo $date"-")
                  fi ;;
              7)  if [ $shiftday -eq 1 ] ; then
                    i=1
                  fi
                  c=$(echo $days | grep -c $i)
                  if [ $c -eq 1 ] ; then
                    date=$(echo $date"S")
                  else
                    date=$(echo $date"-")
                  fi ;;
          esac
          #echo "date: $date"
    done

    channel=$(echo $channel | sed -e s/://g)
    title=$(echo $title | sed -e s/://g)

    SVDRCOMMAND=$(echo updt 1:$channel:$date:$start:$end:$prior:$prior:$title)

else

    if [ "$CMD" != "del" -a "$CMD" != "" ] ; then
        channel=$(echo $QUERY_STRING | cut -d"=" -f2 | cut -d"&" -f1)
        day=$(echo $QUERY_STRING | cut -d"=" -f3 | cut -d"&" -f1)
        month=$(echo $QUERY_STRING | cut -d"=" -f4 | cut -d"&" -f1)
        year=$(echo $QUERY_STRING | cut -d"=" -f5 | cut -d"&" -f1)
        start_hour=$(echo $QUERY_STRING | cut -d"=" -f6 | cut -d"&" -f1)
        start_min=$(echo $QUERY_STRING | cut -d"=" -f7 | cut -d"&" -f1)
        end_hour=$(echo $QUERY_STRING | cut -d"=" -f8 | cut -d"&" -f1)
        end_min=$(echo $QUERY_STRING | cut -d"=" -f9 | cut -d"&" -f1)
        prior=$(echo $QUERY_STRING | cut -d"=" -f10 | cut -d"&" -f1)
        title=$(echo $QUERY_STRING | cut -d"=" -f11 | cut -d"&" -f1 | tr -s "+" "_")

        MARGINSTART=$(cat $VDRCONF/setup.conf | grep "^MarginStart =" | cut -d" " -f3)
        MARGINSTOP=$(cat $VDRCONF/setup.conf | grep "^MarginStop =" | cut -d" " -f3)

        start=$(echo $start_hour:$start_min)
        end=$(echo $end_hour:$end_min)

        # orginal -eq 1
      	if [ $REEL -ge 0 ] ; then
	        startstring=$(echo $year-$month-$day $start_hour:$start_min)
	        endstring=$(echo  $year-$month-$day $end_hour:$end_min)
	      else
	        startstring=$(echo $month$day$start_hour$start_min$year)
        	endstring=$(echo $month$day$end_hour$end_min$year)
        fi

        stimesec=$(date -d "$startstring" +%s)
	      etimesec=$(date -d "$endstring" +%s)

        stimesec=$(($stimesec - $(($MARGINSTART*60))))
        etimesec=$(($etimesec + $(($MARGINSTOP*60))))

				#orginal -eq 1
	       if [ $REEL -ge 0 ] ; then
		        start=$(date -d@$stimesec "+%Y-%m-%d:%H%M")
		        end=$(date -d@$etimesec "+%H%M")
	       else
	          start=$(echo -n $stimesec | awk '{ print strftime("%Y-%m-%d:%H%M", $0) }')
	          end=$(echo -n $etimesec | awk '{ print strftime("%H%M", $0) }')
         fi



        title=$(echo $title | sed -e s/://g)

        SVDRCOMMAND=$(echo updt 1:$channel:$start:$end:$prior:$prior:$title)
    fi
fi

if [ "$SVDRCOMMAND" != "" ] ; then
#  echo $SVDRCOMMAND
  ANSWER=$(/sbin/svdrpsend.sh $SVDRCOMMAND)
#  echo $ANSWER
fi

echo $CT
/bin/cat << EOM

<html>
<head>
<title>$XTIMER</title>
<link rel="stylesheet" media="screen" type="text/css" href="/screen.css">
<link rel="stylesheet" media="handheld" type="text/css" href="/handheld.css">
</head>

<form name="form1" method="GET" action="epg_at.sh">
<table class="chnframe">
EOM

. ./base-menu.sh


/bin/cat << EOM

  <tr>
          <td class="indexitem"><a href="/cgi-bin/timer.sh">$XSETTIMER</a>&nbsp;&nbsp;&nbsp;<a href="/cgi-bin/stimer.sh">$XSTIMER</a></td>
        </tr>
EOM


#./base-lsvdr -l $LANG -m $MAXCHANNELS timers


DATA=$(/sbin/svdrpsend.sh LSTT | tr -s " " "_" | grep ^250)

echo "<tr><td><table class=timertable width=100%>"

for i in $DATA
do
  line=$(echo $i | cut -c5- | tr -s "_" " ")
  nr=$(echo $line | cut -d" " -f1)
  line=$(echo $line | cut -d" " -f2-)
  status=$(echo $line | cut -d":" -f1)

  case $status in
    0) state="!";;
    1) state="&gt;" ;;
    4) state="V";;
    *) state="#";;
  esac

  channr=$(echo $line | cut -d":" -f2)
  date=$(echo $line | cut -d":" -f3)
  start=$(echo $line | cut -d":" -f4)
  starthour=$(echo $start | cut -c1-2)
  startmin=$(echo $start | cut -c3-4)
  start=$(echo $starthour:$startmin)
  end=$(echo $line | cut -d":" -f5)
  endhour=$(echo $end | cut -c1-2)
  endmin=$(echo $end | cut -c3-4)
  end=$(echo $endhour:$endmin)
  prior=$(echo $line | cut -d":" -f6)
  lifetime=$(echo $line | cut -d":" -f7)

  if [ $REEL -eq 1 ] ; then
    title=$(echo $line | cut -d":" -f8 | sed -e s/://g)
  else
    title=$(echo $line | cut -d":" -f8- | sed -e s/://g)
  fi

  chn=$(/sbin/svdrpsend.sh lstc $channr | grep ^250 | cut -d" " -f3- | cut -d":" -f1 | cut -d";" -f1)
  chnlink=$(echo $chn | tr -s " " "_")
  titlelink=$(echo $title | tr -s " " "_")

  echo "<tr><td><a href=/cgi-bin/epg_timer.sh?value=$channr+$chnlink+$date+$start+$end+$titlelink>$nr</a></td><td>$state</td><td class=timername>$chn</td>"
  echo "<td class=timerdatetime>$date ($start - $end)</td>"
  echo "<td class=timerdel><a href=/cgi-bin/timers.sh?del=delt+$nr>X</a>"
  echo "</td></tr><tr><td class=timertitle_list colspan=5>$title</td></tr>"
  echo "<tr><td>&nbsp;</td></tr>"
#debuging
#echo "<tr><td>$TEMP<p>$MARGINSTART<p>$startstring<p>stimesec: $stimesec<p>$start<p>$SVDRCOMMAND<p>$ANSWER</td></tr>"

done


echo "</table></td></tr>"

/bin/cat << EOM
  </tr>
</table>
</body>
</html>
EOM
