#!/bin/sh

. ./base-config.sh

# make sure channel_map is correct
channellist=$VDRCONF/channels.conf         
m3u=/etc/reelhttp-base/reelhttp-videostream.m3u

cnt=0
DATA=""
for i in $(cat $channellist | tr -s " " "_")
do
  if [ $cnt -gt $MAXCHANNELS ] ; then
    break
  else
    DATA=$(echo $DATA $i)
    cnt=$(($cnt+1))
  fi
done

chksum=$(echo $DATA | md5sum | cut -d" " -f1)

# set oldsum
if [ -e /tmp/channellist.chk ] ; then
  oldsum=$(cat /tmp/channellist.chk)
else
  oldsum=0
fi

# check if sums equal
if [ $chksum != $oldsum ] ; then
  #echo "DELETE CHANNEL_MAP"
  rm channel_map
  if [ -e /tmp/streaminglist ] ; then
    rm /tmp/streaminglist
  fi
  rm streamlist.m3u
fi

echo $chksum > /tmp/channellist.chk

if [ ! -e channel_map ] ; then
	./base-lsvdr -l $LANG -t $EPG -m $MAXCHANNELS channels > /dev/null
fi

# now we should have an actual channel_map
# extern or not
EXTERN=""
#EXTERN="Extern/"

REFERER=$(echo "http://"$(echo $HTTP_REFERER | cut -d "/" -f3 | cut -d":" -f1)":3000/"$EXTERN)

# write streamlist


echo "#EXTM3U" > $m3u

for channel in $(cat channel_map | tr -s " " "_")
do
	nr=$(echo $channel | cut -d":" -f1)
	name=$(echo $channel | cut -d":" -f2)
	echo "#EXTINF:-1,$name" >> $m3u
	echo "$REFERER$nr" >> $m3u
done


# pull streamlist

echo $CT
echo ""

/bin/cat << EOM
<html>
<head>
<title>streamlist</title>
<meta http-equiv="refresh" content="0; url=/reelhttp-videostream.m3u">
</head>
<body onload=window.setTimeout('close_window()',1000)>
<p>
loading .... <a href=/cgi-bin/reelhttp-videostream.m3u>(if not click here)</a>
</p>
</body>
</html>
EOM
