#!/bin/sh

cd /opt/reelhttp-addons/bin

. ./addons-config.sh

CMD=$(echo $1 | cut -d"=" -f1)
ARG=$(echo $1 | cut -d"=" -f2-)

LIST=0

case "$CMD" in

  mountnas) #mount NAS
            for i in $(cat /etc/reelhttp-base/cgi-bin/config.sh | grep ^SHARE)
            do
              name=$(echo $i | cut -d":" -f1 | cut -d"=" -f2)
              dir=$(echo $i | cut -d":" -f2 | tr -s "-" "/")
              server=$(echo $i | cut -d":" -f3)
              share=$(echo $i | cut -d":" -f4)
              user=$(echo $i | cut -d":" -f5)
              pwd=$(echo $i | cut -d":" -f6)

              mkdir -p $dir
              mount -t cifs -o username=$user,password=$pwd //$server/$share $dir

              if [ $? -eq 0 ] ; then
                echo "<li>$XMOUNTNAS: $name $XOK"
              else
                echo "<li>$XMOUNTNAS: $name $XFAILED"
              fi

            done

            if [ -e /mnt/hd/video/.update ] ; then
            	rm /mnt/hd/video/.update
            fi
            touch /mnt/hd/video/.update
            ;;
  umountnas) #umount NAS
            for i in $(cat /etc/reelhttp-base/cgi-bin/config.sh | grep ^SHARE)
            do
              name=$(echo $i | cut -d":" -f1 | cut -d"=" -f2)
              dir=$(echo $i | cut -d":" -f2 | tr -s "-" "/")
              ./myumount -f $dir
              if [ $? -eq 0 ] ; then
                echo "<li>$XUMOUNTNAS: $name $XOK"
              else
                echo "<li>$XUMOUNTNAS: $name $XFAILED"
              fi
            done
            if [ -e /mnt/hd/video/.update ] ; then
            	rm /mnt/hd/video/.update
            fi
            touch /mnt/hd/video/.update
            ;;
  getvdrtube) # get vdrtube4reelhttp
            cd /tmp
						echo "get vdrtube4reelhttp ..<br>"
            wget http://hthede.de/dist/vdrtube4reelhttp.tgz > /dev/null
            echo "unpack .. <hr>"
						tar -xzvf vdrtube4reelhttp.tgz -C /
            echo "<hr>make links and directories if needed"

						if [ -e "/media/reel/video/" ] ; then
							if [ ! -d /media/reel/video/vdrtube ] ; then
							  mkdir /media/reel/video/vdrtube
							fi
							if [ -d /opt/reelhttp-addons/vdrtube/webtree ] ; then
							  mv /opt/reelhttp-addons/vdrtube/webtree/* /media/reel/video/vdrtube
							  rmdir /opt/reelhttp-addons/vdrtube/webtree
							fi
							if [ ! -e /opt/reelhttp-addons/vdrtube/webtree ] ; then
							  ln -s  /media/reel/video/vdrtube /opt/reelhttp-addons/vdrtube/webtree
							else
								rm -rf /opt/reelhttp-addons/vdrtube/webtree
							  ln -s  /media/reel/video/vdrtube /opt/reelhttp-addons/vdrtube/webtree
							fi
						else
							if [ ! -d /media/hd/video/vdrtube ] ; then
							  mkdir /media/hd/video/vdrtube
							fi
							if [ -d /opt/reelhttp-addons/vdrtube/webtree ] ; then
							  mv /opt/reelhttp-addons/vdrtube/webtree/* /media/hd/video/vdrtube
							  rmdir /opt/reelhttp-addons/vdrtube/webtree
							fi

							if [ ! -e /opt/reelhttp-addons/vdrtube/webtree ] ; then
							  ln -s  /media/hd/video/vdrtube /opt/reelhttp-addons/vdrtube/webtree
							else
								rm -rf /opt/reelhttp-addons/vdrtube/webtree
							  ln -s  /media/hd/video/vdrtube /opt/reelhttp-addons/vdrtube/webtree
							fi
						fi
            rm vdrtube4reelhttp.tgz
            ;;
  getivdr) # get ivdr4vdrtube
            cd /tmp
			if [ $LANG = "ge" ] ; then
				echo "get ivdr4reelhttp.tgz ...<br>"
				wget http://hthede.de/dist/ivdr4reelhttp.tgz > /dev/null
				echo "unpack ..<hr>"
				tar -xzvf ivdr4reelhttp.tgz -C /
				rm ivdr4reelhttp.tgz
			else
				echo "get ivdr4reelhttp_en.tgz ... <br>"
				wget http://hthede.de/dist/ivdr4reelhttp_en.tgz > /dev/null
				echo "unpack ..<hr>"
				tar -xzvf ivdr4reelhttp_en.tgz -C /
				rm ivdr4reelhttp_en.tgz
			fi
            ;;
  *)        LIST=1
            ;;
esac

if [ $LIST -eq 0 ] ; then
	echo "<hr><p><b>$XDONE!</b><p> <a href=/cgi-bin/addonlist.sh> -> ReelHTTP-Menu</a>"
fi


if [ $LIST -eq 1 ] ; then
  if [ $REEL -eq 1 ] ; then
    echo "<li><a href=/cgi-bin/addon.sh?recsextended.sh target=$TARGET>$XRECORDS ++</a>"
  fi

	#echo "<li><a href=/cgi-bin/addon.sh?media.sh target=$TARGET>mediaplayer </a>"

  if [ $REEL -eq 0 ] ; then
    echo "<li><a href="/cgi-bin/addon.sh?dvdburner.sh=list" target=$TARGET>$XDVDBURNER</a> <i>(for older images try <a href="/cgi-bin/addon.sh?old-dvdburner.sh=list" target=$TARGET>old version</a></i>)"
	else
    echo "<li><a href="/cgi-bin/addon.sh?dvdburner.sh=list" target=$TARGET>$XDVDBURNER</a>"
  fi

  if [ -d /etc/reelhttp-base/vdrtube ] ; then
    echo "<li><a href=/vdrtube/webtree>vdrtube</a>"
  fi

  #mp3 player
  if [ $REEL -eq 1 ] ; then
  	echo "<li><a href="/cgi-bin/addon.sh?mp3player_xine.sh" target=$TARGET>$XMP3PLAYER</a> (using xinemediaplayer)"
	else
	  if [ $(vdr --help | grep -c xinemediaplayer) -eq 1 ] ; then
	  	echo "<li><a href="/cgi-bin/addon.sh?mp3player_xine.sh" target=$TARGET>$XMP3PLAYER</a> (using xinemediaplayer)"
		else
			echo "<li><a href="/cgi-bin/addon.sh?mp3player.sh" target=$TARGET>$XMP3PLAYER</a> (for older images)"
		fi
	fi

  #embedded streamer
  echo "<li><a href="/cgi-bin/addon.sh?streamer_emb.sh=" target=$TARGET>Browser-TV</a>"

  # change backgroundpics
  if [ $REEL -eq 0 ] ; then
    echo "<li><a href="/cgi-bin/addon.sh?favorit2back.sh=" target=$TARGET>$XFAV2BACK</a>"
  fi

  # system stuff
  echo "<li><a href="/cgi-bin/addon.sh?cmd.sh=" target=$TARGET>Shell</a>"

  if [ $(cat /etc/reelhttp-base/cgi-bin/config.sh | grep -c '^SHARE') -ge 1 ] ; then
	  if [ $(mount | grep -c ^"//") -eq 0 ] ; then
			echo "<li><a href=/cgi-bin/addon.sh?addonlist2.sh=mountnas>$XMOUNTNAS</a>"
	  else
			echo "<li><a href=/cgi-bin/addon.sh?addonlist2.sh=umountnas>$XUMOUNTNAS</a>"
	  fi
  fi


fi
