CMD=$2 
DVD=$1
TOBURN=""
archivburn=1
dvdev=/dev/dvd

. ./addons-config.sh

if [ -d /media/reel/ ]; then
	export=/media/reel/video/_reelhttp-dvdburn/
	recs=/media/reel/recordings/
else
	export=/media/hd/video/_reelhttp-dvdburn/
	recs=/media/hd/recordings/
fi

burnlist=/tmp/reelhttp-burnlist
burnlock=/tmp/reelhttp-burn.lock

base=/opt/reelhttp-addons/bin
log=$export/dvd.log
errcount=0

if [ $(echo $CMD | grep "=" > /dev/null) ] ; then
  CMD=$(echo $CMD | cut-d"=" -f1)
  TOBURN=$(echo $CMD | cut-d"=" -f2-)
fi


# first create lockfile
touch $burnlock

# look for swap and change to export
if [ $REEL -eq 0 ] ; then
	$base/mkswapfile.sh
fi

cd $export
mkdir -p _images
mkdir -p _tmp

echo "loginfo:start " $(date +%F-%T) > $log

if [ $(echo $CMD | grep "archiv") ] ; then
  # burn ready iso
  if [ $(echo $TOBURN | grep ".iso" > /dev/null) ] ; then
      $archivburn=0
      if [ $(du -sm $TOBURN | cut -f1) -le $DVD ] ; then
          growisofs -dvd-compat -udf -Z $dvdev $TOBURN
          if [ $? -eq 0 ] ; then
            echo "burn iso dvd" >> $log
            eject $dvdev
          else
            errcount=$(($errcount+1))
            echo "logerror:while burn iso to dvd" >> $log
          fi
      else
          errcount=$(($errcount+1))
          echo "logerror:while burn iso to dvd - too big" >> $log
      fi
  fi 
  # burn ready directory
  if [ $(echo $TOBURN | grep ^"vz-" > /dev/null) ] ; then
      $archivburn=0
      if [ $(du -sm $TOBURN | cut -f1) -le $DVD ] ; then
          growisofs -dvd-compat -Z $dvdev -dvd-video $TOBURN
          if [ $? -eq 0 ] ; then
            echo "burn dvd-vz dvd" >> $log
            eject $dvdev
          else
            errcount=$(($errcount+1))
            echo "logerror:while burn dvd-vz to dvd" >> $log
          fi
      else
          errcount=$(($errcount+1))
          echo "logerror:while burn dvd-vz to dvd - too big" >> $log
      fi
  fi  
  # burn archiv
  if [ $archivburn -eq 1 ] ; then
      
      if [ -e $burnlist ] ; then
        sumsize=0
        thBURNLIST=""        
        
        for j in $(cat $burnlist)
        do
          size=$(du -sm $recs$j | cut -f1)
          sumsize=$(($sumsize + $size))
          thBURNLIST=$(echo $thBURNLIST " " $j)
        done
        echo "loginfo: $sumsize $thBURNLIST" >> $log

        if [ $sumsize -le $DVD ] ; then
            growisofs -dvd-compat -udf -Z $dvdev $thBURNLIST
            if [ $? -eq 0 ] ; then
              echo "burn archiv-dvd dvd" >> $log
              eject $dvdev
            else
              errcount=$(($errcount+1))
              echo "logerror:while burn archiv-dvd to dvd" >> $log
            fi
        else
            errcount=$(($errcount+1))
            echo "logerror:while burn archiv to dvd - too big" >> $log
        fi
      else
        echo "logerror:no_burnlist" >> $log
      fi
  fi
else
  # dvdtitle is first entry 
  for j in $(cat $burnlist)
  do
  	dvdtitle=$(echo $j | cut -d"/" -f1)
  	break
  done
  # start
  
  z=100
  # delete old tmp files
  if [ $(ls | grep -c tmp_) -gt 0 ] ; then  
    rm tmp_*
  fi
  
  #first demux
  for j in $(cat $burnlist)
  do
      echo $(date +%T) " start demuxing of $vz" >> $log
      vz=$(echo "$recs$j")

      # make a link from tmp to dir (due limitations of projektx with  ...)
      if [ -e /tmp/demuxdir ] ; then
        rm /tmp/demuxdir
      fi      
      
      ln -s $vz /tmp/demuxdir
    
      if [ $REEL -eq 0 ] ; then    
  			nice -n 19 /opt/java/bin/java -Djava.awt.headless=true -jar /opt/bin/px_nogui.jar -ini /opt/bin/X.ini -demux -cut /tmp/demuxdir/marks.vdr -out $export -in /tmp/demuxdir/???.vdr  
      else
  			nice -n 19 /usr/lib/jvm/java-6-sun/bin/java  -jar /opt/reelhttp-addons/px/px.jar -ini /opt/reelhttp-addons/px/px.ini -demux -cut /tmp/demuxdir/marks.vdr -out $export /tmp/demuxdir/???.vdr  
      fi

      if [ -e /tmp/demuxdir ] ; then
        rm /tmp/demuxdir
      fi      


      if [ $? -eq 0 ] ; then
        echo "demuxed!" >> $log
      else
        errcount=$(($errcount+1))
        echo "logerror:while demuxing" >> $log
      fi

  		if [ -e 001.ac* ] ; then
  			rm 001.mpa
  			mv 001.ac* tmp_$z.ac3
  		else
  			mv 001.mpa tmp_$z.mpa
  		fi
  		
  		mv 001.mpv tmp_$z.mpv
  
  		z=$(($z+1))
      
      ls -l >> $log	
  done
  
  # ? Size < DVD-Size
  size=$(du -csm tmp_* | grep total | cut -f1)
  
  #if no then calculate requant - factor
  if [ $size -gt $DVD ] ; then
  
  	echo $(date +%T) " start requant: " >> $log
  
  	audiosize=$(du -csm tmp_???.mpa tmp_???.ac3 | grep total | cut -f1)
  	videosize=$(du -csm tmp_???.mpv | grep total | cut -f1)
  	goalsize=$(echo " $DVD - $audiosize " | bc -l)
  	reqfac=$(echo "$videosize / $goalsize" | bc -l)
  	reqfac=$(echo "$reqfac * 1.04" | bc -l)
  	
  	# and requant videostream
  	for j in $(ls tmp_???.mpv)	
  	do
  		nice -n 19 $base/tcrequant -o r-$j -f $reqfac -i $j	

          if [ $? -eq 0 ] ; then
            echo "requant ok!" >> $log
          else
            errcount=$(($errcount+1))
            echo "logerror:while requant" >> $log
          fi
  		
      mv r-$j $j
  	done
    ls -l >> $log
  fi
  
  # multiplex
  for j in $(ls tmp_???.mpv)
  do
  
  	echo $(date +%T) "start mplex of $j" >> $log
  
  	nr=$(echo $j | cut -d"." -f1)
  	if [ -e $nr.ac3 ] ; then
      nice -n 19 mplex -f 8 -o $nr.mpg $nr.mpv $nr.ac3
          if [ $? -eq 0 ] ; then
            echo "mplex with ac3 ok!" >> $log
          else
            errcount=$(($errcount+1))
            echo "logerror:while mplex with ac3" >> $log
          fi
  		rm $nr.mpv $nr.ac3
  	else
  		nice -n 19 mplex -f 8 -o $nr.mpg $nr.mpv $nr.mpa
          if [ $? -eq 0 ] ; then
            echo "mplex with normal audio ok!" >> $log
          else
            errcount=$(($errcount+1))
            echo "logerror:while mplex with normal audio" >> $log
          fi
  		rm $nr.mpv $nr.mpa
  	fi
    ls -l >> $log
  done
  
  # author
  echo $(date +%T) "start authoring" >> $log
  nice -n 19 dvdauthor -t -o dvd $(/bin/ls *.mpg)
          if [ $? -eq 0 ] ; then
            echo "author ok!" >> $log
          else
            errcount=$(($errcount+1))
            echo "logerror:while author" >> $log
          fi
  echo $(date +%T) "start fixing" >> $log
  nice -n 19 dvdauthor -T -o dvd 
          if [ $? -eq 0 ] ; then
            echo "fixing ok!" >> $log
          else
            errcount=$(($errcount+1))
            echo "logerror:while fixing" >> $log
          fi
  ls -l >> $log
  mv dvd vz-$dvdtitle
  if [ -d dvd ] ; then
    rm -rf dvd
  fi

  echo "converted! " $(date +%F-%T) >> $log
  ls -l >> $log
  
  # burn or make iso
  case "$CMD" in
    burn) 	growisofs -dvd-compat -Z $dvdev -dvd-video $dvdtitle
          if [ $? -eq 0 ] ; then
            echo "burn ok!" >> $log
            eject $dvdev
          else
            errcount=$(($errcount+1))
            echo "logerror:while burning" >> $log
          fi
  	         ;;
  	         
  	iso)  nice -n 19 mkisofs -dvd-video -o _images/$dvdtitle.iso vz-$dvdtitle
          if [ $? -eq 0 ] ; then
            echo "make iso ok!" >> $log
            #eject $dvdev
          else
            errcount=$(($errcount+1))
            echo "logerror:while make iso" >> $log
          fi
  	         ;;
  esac
fi
# end and finally delete burnlock
echo "loginfo:ready " $(date +%F-%T) >> $log
rm $burnlock
