#!/bin/sh

. ./addons-config.sh

CMD=$(echo $1 | cut -d"=" -f1)
ARG=$(echo $1 | cut -d"=" -f2-)

if [ -d /media/reel/ ]; then
	export=/media/reel/video/_reelhttp-dvdburn/
	recs=/media/reel/recordings/
else
	export=/media/hd/video/_reelhttp-dvdburn/
	recs=/media/hd/recordings/
fi

burnlist=/tmp/reelhttp-burnlist
burnlock=/tmp/reelhttp-burn.lock
recordlist=/tmp/reelhttp-recordlist
hrecordlist=/tmp/reelhttp-recordlist_html

echo "<tr><td><table=100%>"

#echo $CMD

if [ ! -d $export ] ; then
  mkdir $export
fi

case "$CMD" in
  add)    # add to burnlist
          echo $(cat $recordlist | grep ^$ARG: | cut -d":" -f2) >> $burnlist
           ;;
  del)    mv $burnlist /tmp/tmpfile
  				count=0
  				for i in $(cat /tmp/tmpfile)
  				do
  					count=$(($count+1))
  					if [ ! $count -eq $ARG ] ; then
  						echo "$i" >> $burnlist
  					fi
  				done
  				rm /tmp/tmpfile

            ;;
  delfile)  if [ -e $export/$ARG ] ; then
              rm -rf $export/$ARG
            fi
            ;;
  delcut)	  delmark=$(cat $recordlist | grep ^$ARG: | cut -d":" -f2)
            delmark=$(echo $recs$delmark/marks.vdr)
            rm $delmark
            rm /tmp/reelhttp-recordlist*
            ;;
  refresh_rec)  ./dvd_mklist.sh
            ;;
  refresh_burn) rm $burnlist
            ;;
  del_lock) if [ -e $burnlock ] ; then
              rm $burnlock
            fi
            ;;
  start)    ./dvd_convert.sh $DVD $ARG > $export/dvd.log &
            echo "<tr><td>$XBURNSTARTED&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?dvdburner.sh=list>$XOK</a></td></tr>"
            sleep 5
            ;;
esac

#echo "<tr><td>$CMD $2</td></tr>"


echo "<tr><td>"
echo "<a href=/cgi-bin/addon.sh?dvdburner.sh>$XREFRESH</a>&nbsp;&nbsp;"

# show log or not
if [ -e $export/dvd.log ] ; then
  if [ $(cat $export/dvd.log | grep -c "logerror:") -gt 0 ] ; then
    echo "</td></tr><tr><td>"
    echo "<hr>"
    echo "<b>$XLASTBURNERROR !</b><br>"
    for i in $(cat $export/dvd.log | grep "logerror:" | tr -s " " "_")
    do
      echo $i | tr -s "_" " "
      echo "<br>"
    done
    echo "</td></tr><tr><td><a href=/cgi-bin/addon.sh?viewdvdlog.sh target=$TARGET>$XVIEWBURNLOG</a>&nbsp;&nbsp;"
    echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=delfile=dvd.log>($XDEL)</a></td></tr>"
  else
    echo "$XLASTBURNOK : &nbsp; <a href=/cgi-bin/addon.sh?viewdvdlog.sh target=$TARGET>$XVIEWBURNLOG ?</a>&nbsp;&nbsp;"
    echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=delfile=dvd.log>($XDEL)</a></td></tr>"
  fi
else
  echo "</td></tr>"
fi

# show vz- dvd

if [ $(ls $export/ | grep -c ^"vz-") -gt 0 ] ; then
  echo "<tr><td><hr></td></tr>"
  for i in $(find $export/ -type d -name vz-* )
  do
    linkname=$(echo $i | cut -d"/" -f6-)
    name=$(echo $linkname | cut -c 4-)
    echo "<tr><td>"
    if [ $BURNER -eq 1 ] ; then
      echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=start=archiv=$linkname>$XBURN</a>&nbsp;&nbsp;"
    fi
    echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=delfile=$linkname>$XDEL</a>&nbsp;&nbsp;"
    echo "$name"
    echo "</td></tr>"
  done
fi

# show isos
if [ $(ls $export/_images | grep -c ".iso") -gt 0 ] ; then
  echo "<tr><td><hr></td></tr>"
  for i in $(find $export/_images -name *.iso )
  do
    linkname=$(echo $i | cut -d"/" -f7-)
    name=$(echo $linkname)
    echo "<tr><td>"
    if [ $BURNER -eq 1 ] ; then
      echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=start=archiv=$linkname>$XBURN</a>&nbsp;&nbsp;"
    fi
    echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=delfile=$linkname>$XDEL</a>&nbsp;&nbsp;"
    echo "$name"
    echo "</td></tr>"
  done
fi

# start burnlist
echo "<tr><td><hr></td></tr>"

if [ -e $burnlist ] ; then


  echo "<tr><td><b>$XINBURNLIST:&nbsp;&nbsp;</b><a href=/cgi-bin/addon.sh?dvdburner.sh=refresh_burn>$XNEW</a></td></tr>"

  sumsize=0
	burncount=0

  for i in $(cat $burnlist)
  do
    name=$(echo $i | sed -e s/".[[:digit:]][[:digit:]].[[:digit:]][[:digit:]].rec\/"//g)
    size=$(du -sm $recs/$i | cut -f1)
    sumsize=$(($sumsize + $size))
    burncount=$(($burncount+1))
    echo "<tr><td>&nbsp;<a href=/cgi-bin/addon.sh?dvdburner.sh=del=$burncount>-</a>&nbsp;&nbsp;($size)&nbsp;$name</td></tr>"
  done
  echo "<tr><td><b>$sumsize MB</b>&nbsp;&nbsp;"

  if [ -e $burnlock ] ; then
      echo "$XBURNINPROCESS&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?dvdburner.sh=del_lock>$XDELBURNLOCK</a>"
  else
      if [ -d /opt/java -o $REEL -eq 1 ] ; then
        echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=start=iso>$XISO</a>&nbsp;&nbsp;"
      fi
      if [ $BURNER -eq 1 ] ; then
        if [ -d /opt/java -o $REEL -eq 1 ] ; then
          echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=start=burn>$XBURN</a>&nbsp;&nbsp;"
        fi
        echo "<a href=/cgi-bin/addon.sh?dvdburner.sh=start=archiv>$XARCHIV</a>&nbsp;&nbsp;"
      fi
  fi
  echo "</td></tr>"
  echo "<tr><td><hr></td></tr>"
fi

# show records
# first check, if records are changed
chksum=$(find $recs -type d | md5sum | cut -d" " -f1)

# set oldsum
if [ -e /tmp/recordlist.chk -a -e $hrecordlist ] ; then
  oldsum=$(cat /tmp/recordlist.chk)
else
  oldsum=0
fi

# check if sums equal
if [ $chksum != $oldsum ] ; then
  # need to rebuild list
  echo "<tr><td>$XNEEDTOREBUILD</td></tr>"
  ./dvd_mklist.sh
  echo $chksum > /tmp/recordlist.chk
fi

cat $hrecordlist

echo "</table></td></tr>"
