#!/bin/bash
#
# externremux.sh

# first read config from base - dir
cd /etc/reelhttp-base/cgi-bin
 . ./base-config.sh
cd /root

MENCODER="/usr/bin/mencoder"
TMP=$(mktemp -d -t &{TMP_DIR}/externmux.sh.XXXXXXXXXX)
trap "rm -rf $TMP" EXIT HUP INT TERM ABRT
mkfifo $TMP/out.avi
cat $TMP/out.avi &

case $EXTERNQUAL in
     DSL1000) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=100 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=160:104 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
     DSL2000) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=128 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=160:104 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
     DSL3000) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=250 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=320:208 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
     DSL6000) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=350 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=320:208 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
	 DSL16000) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=832 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=640:480 \
                -audio-delay -0.025 -o $TMP/out.avi -- - &>$TMP/out.log ;;
       LAN10) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=4096 \
                -oac mp3lame -lameopts preset=standard \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
      WLAN11) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=768 \
                -oac mp3lame -lameopts preset=standard -vf scale=640:408 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
      WLAN54) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=2048 \
                -oac mp3lame -lameopts preset=standard \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
        PDA) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=350 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=320:208 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
        n800) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=350 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=400:200 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;
		P480) $MENCODER -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=832 \
                -oac mp3lame -lameopts preset=15:mode=3 -vf scale=480:320 \
                -o $TMP/out.avi -- - &>$TMP/out.log ;;

           *) touch $TMP/out.avi ;;
esac

