#!/bin/sh

. ./addons-config.sh

CMD=$(echo $1 | cut -d"=" -f1)
ARG=$(echo $1 | cut -d"=" -f2-)
REFERER=$(cat /tmp/referer)

if [ -d "/media/reel/music" ] ; then
	music="/media/reel/music"
else
	if [ $REEL -eq 1 ] ; then
		music=/media/hd/music
	else
		music=/mnt/hd/music
	fi
fi

space=__

echo "<tr><td><table=100%>"
# first check, if mp3s are changed
chksum=$(find $music | md5sum | cut -d" " -f1)

# set oldsum
if [ -e /tmp/mp3list.chk -a -e /tmp/mp3list ] ; then
  oldsum=$(cat /tmp/mp3list.chk)
else
  oldsum=0
fi

case "$CMD" in
  playdir)  # playing whole dir
            ./mp3start.sh $CMD $ARG > /dev/null &    
            echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;
  playfile) # play a file
            ./mp3start.sh $CMD $ARG > /dev/null &    
            echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;
  cmd)      #send command
            if [ $ARG = "skiprew" ] ; then
              #currently unused to better idea to implement
              /sbin/svdrpsend.sh hitk down > /dev/null
              /sbin/svdrpsend.sh hitk down > /dev/null
            else
              /sbin/svdrpsend.sh hitk $ARG > /dev/null
            fi
            ;;
  show)     #showdir
            if [ -e /tmp/mp3dir ] ; then
              rm /tmp/mp3dir
            fi
            vz=$(echo $ARG | sed s/$space/" "/g)
            
            if [ $(echo $vz | grep -c ".m3u") -eq 1 ] ; then
              # show playlist
              for i in $(cat "$vz" | sed s/" "/$space/g)
              do
                name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f1-)
                file=$(echo $music"/"$i)
                echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh=playfile=$file>$XPLAY</a>&nbsp;&nbsp;$name</td></tr>" >> /tmp/mp3dir
              done
              echo "<tr><td class=timerdel><a href=/cgi-bin/addon.sh?mp3player.sh=closedir>$XCLOSE</a></td></tr>" >> /tmp/mp3dir
              echo "<tr><td><hr></td></tr>" >> /tmp/mp3dir
            else
              # show dir
              for i in $(find "$vz" -type f | sed s/" "/$space/g)
              do
                name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f5-)
                echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh=playfile=$i>$XPLAY</a>&nbsp;&nbsp;$name</td></tr>" >> /tmp/mp3dir
              done
              echo "<tr><td class=timerdel><a href=/cgi-bin/addon.sh?mp3player.sh=closedir>$XCLOSE</a></td></tr>" >> /tmp/mp3dir
              echo "<tr><td><hr></td></tr>" >> /tmp/mp3dir
            fi
            ;;
  closedir) rm /tmp/mp3dir
            ;;
  stop)
      killall vlc
      ;;
esac

# show current song
CURR=$(/sbin/svdrpsend.sh plug mp3 curr | grep ^900)
if [ $? -eq 0 ] ; then
  name=$(echo $CURR | cut -d"/" -f5-)
  echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh>$XREFRESH</a>&nbsp;&nbsp;"
  # currently unused due idea to implement
  #echo "<a href=/cgi-bin/addon.sh?mp3player.sh=cmd=skiprew>$XSKIPREW</a>&nbsp;&nbsp;"
  echo "<a href=/cgi-bin/addon.sh?mp3player.sh=cmd=down>$XBEGIN</a>&nbsp;&nbsp;"
  echo "<a href=/cgi-bin/addon.sh?mp3player.sh=cmd=up>$XSKIPFFW</a>&nbsp;&nbsp;"
  echo "<a href=/cgi-bin/addon.sh?mp3player.sh=cmd=pause>$XPAUSE</a>&nbsp;&nbsp;"
  echo "<a href=/cgi-bin/addon.sh?mp3player.sh=cmd=back>$XSTOP</a></td></tr>"
  echo "<tr><td>$XCURRENT $name</td></tr>"
  echo "<tr><td><hr></td></tr>"
fi

if [ $(ps x | grep -c vlc) -gt 1 ] ; then
  echo "<tr><td><a href=http://$REFERER/viewstream.m3u target=_blank>$XPLAYSTREAM</a> | <a href=http://$REFERER:3002 target=_blank>$XINTERFACE</a> | <a href=/cgi-bin/addon.sh?mp3player.sh=stop>$XSTOP</a><table=100%>"
  echo "<tr><td><hr></td></tr>"
fi

# show mp3dir if available
if [ -e /tmp/mp3dir ] ; then
  cat /tmp/mp3dir
fi  

# check if sums equal
if [ $chksum != $oldsum ] ; then
  # need to rebuild list
  echo "<tr><td>$XNEEDTOREBUILD</td></tr>"
  if [ -e /tmp/mp3list ] ; then
    rm /tmp/mp3list
  fi
  # playlist
  echo "<tr><td><b>playlists:</b></td></tr>" >> /tmp/mp3list
  for i in $(find $music/*.m3u -type f | sed s/" "/$space/g)
  do
     name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f5- | sed -e s/".m3u"//g)
     echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh=playfile=$i>$XPLAY</a>&nbsp;&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?mp3player.sh=show=$i>$name</a></td></tr>" >> /tmp/mp3list
  done
  echo "<tr><td><hr></td></tr>" >> /tmp/mp3list
  # play dirs
  echo "<tr><td><b>dir's:</b></td></tr>" >> /tmp/mp3list
  for i in $(find $music/* -type d | sed s/" "/$space/g)
  do
    if [ $MP3LISTMODE -eq 0 ] ; then
      vz=$(echo $i | sed s/$space/" "/g)
      if [ $(ls -l "$vz" | grep -c ^-) -gt 0 ] ; then
        name=$(echo $vz | cut -d"/" -f5-)
        echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh=playdir=$i>$XPLAY</a>&nbsp;&nbsp;" >> /tmp/mp3list
        echo "<a href=/cgi-bin/addon.sh?mp3player.sh=show=$i>$name</a></td></tr>" >> /tmp/mp3list
      fi        
    else  
      name=$(echo $vz | cut -d"/" -f5-)
      echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player.sh=playdir=$i>$XPLAY</a>&nbsp;&nbsp;" >> /tmp/mp3list
      echo "<a href=/cgi-bin/addon.sh?mp3player.sh=show=$i>$name</a></td></tr>" >> /tmp/mp3list
    fi
  done
  
  echo $chksum > /tmp/mp3list.chk
fi

cat /tmp/mp3list

echo "</table></td></tr>"
