#!/bin/sh

. ./addons-config.sh

CMD=$(echo $1 | cut -d"=" -f1)
ARG=$(echo $1 | cut -d"=" -f2-)
REFERER=$(cat /tmp/referer)
m3u=/tmp/reelhttp-mp3.m3u
mp3dir=/tmp/reelhttp-single-mp3dir
mp3dir_html=/tmp/reelhttp-single-mp3dir_html
mlist=/tmp/reelhttp-musiclist
mlist_html=/tmp/reelhttp-musiclist_html
space=___
refresh=0

if [ -d "/media/reel/music" ] ; then
	music="/media/reel/music"
else
	if [ $REEL -eq 1 ] ; then
		music=/media/hd/music
	else
		music=/mnt/hd/music
	fi
fi

echo "<tr><td><table=100%>"
# first check, if mp3s are changed
chksum=$(find $music/ | md5sum | cut -d" " -f1)

#echo chksum: $chksum; $(ls /tmp)

# set oldsum
if [ -e /tmp/mp3list.chk -a -e $mlist ] ; then
  oldsum=$(cat /tmp/mp3list.chk)
else
  oldsum=0
fi

case "$CMD" in
  playdir)  # playing whole dir
            ./mp3start_xine.sh $CMD $ARG > /dev/null &
            echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;
  playpl)  # playing whole dir
            ./mp3start_xine.sh $CMD $ARG > /dev/null &
            echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;

  playfile) # play a file
            ./mp3start_xine.sh $CMD $ARG > /dev/null &
            echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;
  cmd)      #send command
            if [ $ARG = "skiprew" ] ; then
              #currently unused to better idea to implement
              /sbin/svdrpsend.sh hitk down > /dev/null
              /sbin/svdrpsend.sh hitk down > /dev/null
            else
              /sbin/svdrpsend.sh hitk $ARG > /dev/null
            fi

            # delete m3u - List when stop
            if [ $ARG = "stop" ] ; then
							if [ -e $m3u ] ; then
            		rm $m3u
            	fi
            fi

            ;;
  show)     #showdir
            if [ -e $mp3dir_html ] ; then
              rm $mp3dir_html $mp3dir
            fi
            vz=$(cat $mlist | grep ^$ARG: | cut -d":" -f2-)
            #echo "hallo" >> $mp3dir

            if [ $(echo $vz | grep -c ".m3u") -eq 1 -o $(echo $vz | grep -c ".playlist") -eq 1 ] ; then
              # show playlist
              count=0
              for i in $(cat "$vz" | grep -v ^# | sed s/" "/$space/g)
              do
              	#echo line: $i
              	count=$(($count+1))
              	file=$(echo $i | sed s/$space/" "/g)
								echo "$count:$file" >> $mp3dir
                name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f1-)
                echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playfile=$count>$XPLAY</a>&nbsp;&nbsp;$name</td></tr>" >> $mp3dir_html
              done
              #echo mp3dir: $(cat $mp3dir)
              echo "<tr><td class=timerdel><a href=/cgi-bin/addon.sh?mp3player_xine.sh=closedir>$XCLOSE</a></td></tr>" >> $mp3dir_html
              echo "<tr><td><hr></td></tr>" >> $mp3dir_html
            else
              # show dir
              count=0
              for i in $(find "$vz" -type f | sed s/" "/$space/g)
              do
              	count=$(($count+1))
              	file=$(echo $i | sed s/$space/" "/g)
								echo "$count:$file" >> $mp3dir
                name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f5-)
                echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playfile=$count>$XPLAY</a>&nbsp;&nbsp;$name</td></tr>" >> $mp3dir_html
              done
              echo "<tr><td class=timerdel><a href=/cgi-bin/addon.sh?mp3player_xine.sh=closedir>$XCLOSE</a></td></tr>" >> $mp3dir_html
              echo "<tr><td><hr></td></tr>" >> $mp3dir_html
            fi
            #echo  mp3dir: $(cat $mp3dir)
            ;;
  closedir) rm $mp3dir_html $mp3dir
            ;;
  stop)
      killall vlc
			if [ -e $m3u ] ; then
	  		rm $m3u
	  	fi
      ;;
  refresh)
  		refresh=1
  		;;
esac

# show current song
if [ -e $m3u ] ; then
	echo "<tr><td><b>$XRC:</b>"
	if [ -e /tmp/rh_stream ] ; then
     if [ -e /tmp/rh_stream_extern -a -e /root/externremux.sh ] ; then
     		echo "$XNORMALSTREAM: <a href=/viewstream.m3u target=_blank>$XHEARSTREAM</a> <a href=http://$REFERER:3002 target=_blank>($XINTERFACE)</a>"
     else
     		echo "$XNORMALSTREAM: <a href=/viewstream.m3u target=_blank>$XHEARSTREAM</a> <a href=http://$REFERER:3002 target=_blank>($XINTERFACE)</a>"
     fi
  else
  	echo "$XNORMALPLAY"
  fi
	echo "; <a href=/cgi-bin/addon.sh?mp3player_xine.sh=refresh>$XREFRESH</a>&nbsp;&nbsp;"

	# currently unused due idea to implement
	#echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=cmd=skiprew>$XSKIPREW</a>&nbsp;&nbsp;"
	echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=cmd=down>$XBEGIN</a>&nbsp;&nbsp;"
	echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=cmd=up>$XSKIPFFW</a>&nbsp;&nbsp;"
	echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=cmd=pause>$XPAUSE</a>&nbsp;&nbsp;"
	echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=cmd=stop>$XSTOP</a></td></tr>"
else
	echo "<tr><td>"
	if [ -e /tmp/rh_stream ] ; then
     if [ -e /tmp/rh_stream_extern -a -e /root/externremux.sh ] ; then
     		echo "$XNORMALSTREAM"
     else
     		echo "$XNORMALSTREAM"
     fi
  else
  	echo "$XNORMALPLAY"
  fi
	echo "; <a href=/cgi-bin/addon.sh?mp3player_xine.sh=refresh>($XREFRESH)</a>"
fi
echo "<tr><td><hr></td></tr>"

#if [ $(ps x | grep -c vlc) -gt 1 ] ; then
#  echo "<tr><td><a href=http://$REFERER/viewstream.m3u target=_blank>$XPLAYSTREAM</a> | <a href=http://$REFERER:3002 target=_blank>$XINTERFACE</a> | <a href=/cgi-bin/addon.sh?mp3player_xine.sh=stop>$XSTOP</a><table=100%>"
#  echo "<tr><td><hr></td></tr>"
#fi

# show mp3dir if available
if [ -e $mp3dir_html ] ; then
  cat $mp3dir_html
fi

# check if sums equal
if [ $chksum != $oldsum -o $refresh -eq 1 ] ; then
  # need to rebuild list
  echo "<tr><td>$XNEEDTOREBUILD</td></tr>"
  if [ -e $mlist ] ; then
    rm $mlist $mlist_html
  fi
  count=0
  # playlist (m3u)
  echo "<tr><td><b>$XPLAYLIST:</b></td></tr>" >> $mlist_html
    for i in $(find $music/*.m3u -type f | sed s/" "/$space/g)
  do
  	 count=$(($count+1))
  	 vz=$(echo $i | sed s/$space/" "/g)
  	 echo "$count:$vz" >> $mlist
     name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f5- | sed -e s/"\.m3u"//g)
     echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playpl=$count>$XPLAY</a>&nbsp;&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?mp3player_xine.sh=show=$count>$name</a></td></tr>" >> $mlist_html
  done
  for i in $(find $music/*.playlist -type f | sed s/" "/$space/g)
  do
  	 count=$(($count+1))
  	 vz=$(echo $i | sed s/$space/" "/g)
  	 echo "$count:$vz" >> $mlist
     name=$(echo $i | sed s/$space/" "/g | cut -d"/" -f5- | sed -e s/"\.playlist"//g)
     echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playpl=$count>$XPLAY</a>&nbsp;&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?mp3player_xine.sh=show=$count>$name</a></td></tr>" >> $mlist_html
  done

  echo "<tr><td><hr></td></tr>" >> $mlist_html
  # play dirs
  echo "<tr><td><b>$XDIR</b></td></tr>" >> $mlist_html
  for i in $(find $music/* -type d | sed s/" "/$space/g)
  do
    count=$(($count+1))
		vz=$(echo $i | sed s/$space/" "/g)
    echo "$count:$vz" >> $mlist
    if [ $MP3LISTMODE -eq 0 ] ; then
      if [ $(ls -l "$vz" | grep -c ^-) -gt 0 ] ; then
        name=$(echo $vz | cut -d"/" -f5-)
        echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playdir=$count>$XPLAY</a>&nbsp;&nbsp;" >> $mlist_html
        echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=show=$count>$name</a></td></tr>" >> $mlist_html
      fi
    else
      name=$(echo $vz | cut -d"/" -f5-)
      echo "<tr><td><a href=/cgi-bin/addon.sh?mp3player_xine.sh=playdir=$count>$XPLAY</a>&nbsp;&nbsp;" >> $mlist_html
      echo "<a href=/cgi-bin/addon.sh?mp3player_xine.sh=show=$i>$name</a></td></tr>" >> $mlist_html
    fi
  done

  echo $chksum > /tmp/mp3list.chk
fi

cat $mlist_html

echo "</table></td></tr>"
