#!/bin/sh

. ./addons-config.sh

CMD=$(echo $1 | cut -d"=" -f1)
ARG=$(echo $1 | cut -d"=" -f2-)

if [ -e "/media/reel/" ] ; then
	recs="/media/reel/recordings"
	MPGDIR="/media/reel/video"
	MP3DIR="/media/reel/music/_vdr2mp3"
else
	if [ -e "/media/hd/recordings" ] ; then
	  recs="/media/hd/recordings"
	else
	  recs="/media/hd/video"
	fi
	MPGDIR="/media/hd/video"
	MP3DIR="/media/hd/music/_vdr2mp3"
fi

space=__
REFERER=$(cat /tmp/referer | cut -d"/" -f3)
REC=$(cat /tmp/streamreclist | grep ^$ARG: | cut -d":" -f2)

echo "#EXTM3U\n#EXTINF:-1,ReelStream\nhttp://"$REFERER":3001" > /etc/reelhttp-base/viewstream.m3u

# instead m3u create pls, change also row 115 or so
#echo "[playlist]\nNumberOfEntries=1\n\nFile1=http://"$REFERER":3001\nTitle1=ReelStream\nLength1=-1\n\nVersion=2" > /etc/reelhttp-base/viewstream.pls

REFERER2="http://$(echo $REFERER:3001)"

case "$CMD" in
  refresh) # rebuild file list manually
	    rm /tmp/streamrec*
	    sleep 3
	    ;;
  play) # play a file
            #./mp3start.sh $CMD $ARG > /dev/null &
            killall vlc
            echo "<tr><td><b>playing</b>: $REC <a href=/cgi-bin/addon.sh?recsextended.sh=stop>STOP</a></td></tr>"
            ./streamrec.sh $REC &
			echo "<tr><td>streaming url: <i>http://$REFERER:3001</i></td></tr>"
			echo "<tr><td><hr></td></tr>"
            sleep 1
            ;;
#### here you can add more commands to do
  vdrtube) # make vdrtube
           if [ $(ps x | grep -c vdrtube) -ge 3 ] ; then
              echo "<tr><td>$XWAIT (vdrtube always running)</td></tr>"
              echo "<tr><td><hr></td></tr>"
           else
              echo "<tr><td>vdrtube $REC</td></tr>"
              echo "<tr><td><hr></td></tr>"
              cd /opt/reelhttp-addons/vdrtube
              echo "perl vdrtube.pl $REC" | at now
              cd /opt/reelhttp-addons/bin
           fi
           ;;
  vdr2mpg) # make mpeg
           if [ $(ps x | grep -c replex) -ge 1 ] ; then
              echo "<tr><td>$XWAIT (a conversion is always running)</td></tr>"
              echo "<tr><td><hr></td></tr>"
           else
              echo "<tr><td>vdr2mpg $REC</td></tr>"
              echo "<tr><td><hr></td></tr>"
	      linkname=$(echo $REC | sed -e s/".[[:digit:]][[:digit:]].[[:digit:]][[:digit:]].rec\/"//g | sed -e s/"#5F"/"_"/g)
              MPGNAME=$(echo $linkname | tr -s "/" "-" | tr -s "." "_" | tr -s " " "_" | sed -e s/"-media-hd-recordings-"/""/g)
	      MPGNAME=$(/etc/reelhttp-base/cgi-bin/delspecialchar.sh $MPGNAME)
	      #echo "replex -t MPEG2 -o $MPGDIR/$MPGNAME.mpg $REC???.vdr"
	      echo "replex -t MPEG2 -o "$MPGDIR/$MPGNAME.mpg" $REC???.vdr" | at now
           fi
           ;;
  vdr2mp3) # make mp3
           if [ -e /tmp/vdr2mpg.run ] ; then
              echo "<tr><td>$XWAIT (a conversion is always running)</td></tr>"
              echo "<tr><td><hr></td></tr>"
           else
			  if [ ! -d $MP3DIR ] ; then
				mkdir $MP3DIR
			  fi
              echo "<tr><td>vdr2mp3 $REC</td></tr>"
              echo "<tr><td><hr></td></tr>"
              MPGNAME=$(echo $REC | cut -d"/" -f5- | tr -s "/" "-" | tr -s "." "_")
	      MPGNAME=$(/etc/reelhttp-base/cgi-bin/delspecialchar.sh $MPGNAME)
              echo "touch /tmp/vdr2mp3.run && replex --demux --audio_only -o $MP3DIR/tmp $REC???.vdr && lame $MP3DIR/tmp0.mp2 $MP3DIR/$MPGNAME.mp3 && rm $MP3DIR/tmp0.mp2 && rm /tmp/vdr2mp3.run" | at now
           fi
           ;;



  stop)     # stop vlc
            killall vlc
	    sleep 2
            ;;
  *)        # all the rest
			if [ $(ps x | grep -c "vlc -vvv /media") -ge 1 ] ; then
			  CURR=$(ps x | grep "vlc -vvv /media" | tr -s " " | cut -d" " -f7)
			  echo "<tr><td><b>stream: </b>$CURR <a href=/cgi-bin/addon.sh?recsextended.sh=stop>STOP</a></td></tr>"
			  echo "<tr><td>streaming url: <i>http://$REFERER:3001</i></td></tr>"
			  echo "<tr><td><hr></td></tr>"
			fi
			;;
esac

echo "<tr><td><a href=/cgi-bin/addon.sh?recsextended.sh>[$XREFRESH]</a>"

if [ -d /etc/reelhttp-base/vdrtube ] ; then
    echo "&nbsp;&nbsp;<a href=/vdrtube/webtree target=_blank>[$XSHOW vdrtube]</a>"
fi

if [ $(ps aux | grep -c vlc) -ge 1 ] ; then
	# direct call doesnt work, disable until solution, then -eq 1
	if [ $STREAMURL -eq 9 ] ; then
		echo "&nbsp;&nbsp;<a href=$REFERER2 target=_blank>[$XSEESTREAM]</a>&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?recsextended.sh=stop>[STOP Stream]</a>&nbsp;&nbsp;<a href=http://$REFERER:3002 target=_blank>[$XINTERFACE]</a>"
	else
		echo "&nbsp;&nbsp;<a href=/viewstream.m3u target=_blank>[$XSEESTREAM]</a>&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?recsextended.sh=stop>[STOP Stream]</a>&nbsp;&nbsp;<a href=http://$REFERER:3002 target=_blank>[$XINTERFACE]</a>"
	fi
fi
echo "<hr></td></tr>"


# first check, if recordings are changed
#rm /tmp/streamreclist
chksum=$(find $recs | md5sum | cut -d" " -f1)

# set oldsum
if [ -e /tmp/recs.chk -a -e /tmp/streamreclist ] ; then
  oldsum=$(cat /tmp/recs.chk)
else
  oldsum=0
fi

echo $chksum > /tmp/recs.chk

# check if sums equal
#oldsum=0
if [ $chksum != $oldsum ] ; then
  # need to rebuild list
  echo "<tr><td>$XNEEDTOREBUILD</td></tr>"
  if [ -e /tmp/streamreclist ] ; then
    rm /tmp/streamreclist
  fi
  if [ -e /tmp/streamreclist_html ] ; then
    rm /tmp/streamreclist_html
  fi
  count=1

  for i in $(find $recs/ -name 001.vdr | cut -d"/" -f5- | sed -e s/"001\.vdr"//g | tr -s " " "_")
  do
    #echo "line: " $i
    linkname=$(echo $i | sed -e s/".[[:digit:]][[:digit:]].[[:digit:]][[:digit:]].rec\/"//g | sed -e s/"#5F"/" "/g)
    link=$(echo $count":"$recs"/"$i)
    echo $link >> /tmp/streamreclist
#### here you can add more commands to list (befor linkname)
    if [ -e /usr/bin/replex ] ; then
	vdr2mpgtext="<tr><td><a href=/cgi-bin/addon.sh?recsextended.sh=vdr2mpg=$count>[mpg]</a>"
    fi

    if [ -e /usr/bin/lame ] ; then
	vdr2mp3text="&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?recsextended.sh=vdr2mp3=$count>[mp3]</a>"
    fi

    if [ -d /etc/reelhttp-base/vdrtube ] ; then
	tubetext="&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?recsextended.sh=vdrtube=$count>[vdrtube]</a>"
    fi

    # AVG Stuff only
    if [ -e /usr/bin/vlc ] ; then
	streamtext="&nbsp;&nbsp;<a href=/cgi-bin/addon.sh?recsextended.sh=play=$count>[stream]</a>"
    fi

    # end the rest
    echo "$vdr2mpgtext $vdr2mp3text $tubetext $streamtext $linkname</td></tr>" >> /tmp/streamreclist_html
    count=$(($count + 1))
  done
fi
cat /tmp/streamreclist_html
echo "<tr><td><hr><a href=/cgi-bin/addon.sh?recsextended.sh=refresh>[$XREFRESH_REC]</a>"
